<template>
  <bubble-menu
    v-if="editorRef"
    :editor="editorRef"
    plugin-key="tableColumnMenu"
    :should-show="shouldShowColumnMenu"
    :update-delay="0"
    :tippy-options="{ 
      offset: [0, 15],
      popperOptions: {
        modifiers: [{ name: 'flip', enabled: false }],
      },
      appendTo: () => {
        return elementTarget
      },
    }"
  >
    <div id="tableColumnMenu" class="w-[220px] max-h-[496px] rounded-[4px] py-2 h-full flex flex-col bg-surface cardShadow">
      <v-list
        color="primary"
        density="compact"
        class="!py-0 w-full"
      >
        <v-list-item
          v-for="(item, index) in items"
          :key="item.value"
          :value="item.value"
          :active="false"
          @click="item?.onClick()"
        >
          <div class="w-full flex gap-3 whitespace-nowrap">
            <div>
              <Icon
                :icon="item?.icon"
                height="24"
                width="24"
                :class="item?.iconClass"
              />
            </div>
    
            <svn-pro-text
              regular
              bodyLarge
              class="truncate text-ellipsis"
              :color="index === items?.length - 1 ? 'error' : 'onSurface'"
            >
              {{ item.title }}
            </svn-pro-text>
          </div>
        </v-list-item>
      </v-list>
    </div>
  </bubble-menu>
</template>

<script setup>
import { Icon } from '@iconify/vue';
import { watch, ref, onMounted } from 'vue';
import { Editor, BubbleMenu } from '@tiptap/vue-3';
import SvnProText from '../../styles/SvnProText.vue';
import { isColumnGripSelected } from '../utils/isColumnGripSelected.js';

onMounted(() => {
  editorRef.value = props.editor;
});

const props = defineProps({
  editor: { type: Editor, default: () => {}, required: true },
  elementTarget: { type: undefined, default: null },
});

const editorRef = ref(null);

const shouldShowColumnMenu = ({ view, state, from }) => {
  if (!props.editor.state) {
    return false
  }

  return isColumnGripSelected({ editor: props.editor, view, state, from: from || 0 });
}

const onAddColumnBefore = () => {
  props.editor.chain().focus().addColumnBefore().run();
}

const onAddColumnAfter = () => {
  props.editor.chain().focus().addColumnAfter().run();
}

const onDeleteColumn = () => {
  props.editor.chain().focus().deleteColumn().run();
}

const items = [
  {
    value: "add_before",
    title: "Add column before",
    icon: "mingcute:arrow-to-left-line",
    iconClass: "text-onSurfaceVariant",
    onClick: () => onAddColumnBefore()
  },
  {
    value: "add_after",
    title: "Add column after",
    icon: "mingcute:arrow-to-right-line",
    iconClass: "text-onSurfaceVariant",
    onClick: () => onAddColumnAfter()
  },
  {
    value: "delete_column",
    title: "Delete column",
    icon: "mingcute:delete-2-line",
    iconClass: "text-error",
    onClick: () => onDeleteColumn()
  },
]

watch(props, (newValue, oldValue) => {
  if (newValue.editor) {
    editorRef.value = props.editor
  }
});
</script>

<style scoped>
.cardShadow {
  box-shadow: 0px 2px 2px 0px rgba(0, 0, 0, 0.14), 0px 3px 1px 0px rgba(0, 0, 0, 0.12), 0px 1px 5px 0px rgba(0, 0, 0, 0.20);
}
</style>